d("customBuyAgainView", ['ccrz', 'util', 'customBuyAgainModel'], function (CCRZ, UTIL, customBuyAgainModel) {

    return {
        extendcustomBuyAgainView: function () {
            CCRZ.custom = _.extend(CCRZ.custom || {});
            CCRZ.custom.views = _.extend(CCRZ.custom.views || {});
            CCRZ.custom.models = _.extend(CCRZ.custom.models || {});
            CCRZ.remoteActions = _.extend(CCRZ.remoteActions || {});
            let buyAgainBackUpModel = '';
            let buyAgainBackUpSearchFormData = {
                'searchInput': '',
                'fromDateStr': '',
                'toDateStr': '',
            };
            CCRZ.views.customBuyAgainView = CCRZ.CloudCrazeView.extend({
                el: CCRZ.uiProperties.customBuyAgainView.desktop.selector,
                viewName: "customBuyAgainView",
                subscriptionTemplate: CCRZ.util.template(CCRZ.uiProperties.customBuyAgainView.desktop.tmpl),
                init: function () {
                    UTIL.showLoader();
                    this.listenTo(this.model, "reset", this.ready);
                    this.dataLoadStarted = false;
                    this.dataReady = false;
                    this.dataModel = this.model;
                },
                initSetup: function(callback) {
                    //CCRZ-2335 : Different Tabs under MyAccount do not pull data real-time
                    //reset the dataLoadStarted and dataReady flags and refresh the view
                    this.dataLoadStarted = false;
                    this.dataReady = false;
                    buyAgainBackUpSearchFormData = {
                        'searchInput': '',
                        'fromDateStr': '',
                        'toDateStr': '',
                    };
                    callback();
                },
                preRender: function() {
                    UTIL.showLoader();
                    let v = this;
                    if(!v.dataLoadStarted) {
                        v.dataModel.fetch(function (res, event) {
                            if (res && res.data) {
                                v.recentProducts = res.data.recentProducts;
                                buyAgainBackUpModel = res.data.recentProducts;
                                v.dataReady = true; 
                                v.render();
                            }
                        });
                        v.dataLoadStarted=true;
                    }
                },
                renderDesktop: function () {
                    if(this.dataReady) {
                        this.renderData();
                    }
                },
                renderPhone: function() {
                    if(this.dataReady) {
                        this.renderData();
                    }
                },
                renderData: function() {
                    let _this = this;
                    if(!_this.model.recentProducts && buyAgainBackUpModel) {
                        _this.model.set('recentProducts', buyAgainBackUpModel);
                    }
                    if(!_this.model.searchFormData && buyAgainBackUpSearchFormData) {
                        _this.model.set('searchFormData', buyAgainBackUpSearchFormData);
                    }
                    _this.$el.html(this.subscriptionTemplate(this.model.toJSON()));

                    var formData = _this.model.searchFormData || {};
                    //populate search order form data
                    _this.model.searchOrder = formData.searchOrder || '';
                    _this.model.fromDateStr = formData.fromDateStr || '';
                    _this.model.toDateStr = formData.toDateStr || '';

                    _this.updateDatePicker();
                    setTimeout(function () {
                        UTIL.hideLoader();
                    }, 100);
                },
                events: {
                    "click .addToCart": "handleAddToCart",
                    "click .searchBuyAgain" : "handleBuyAgainSearch",
                    "click .resetBuyAgain" : "resetSearch",
                    "click .cc_reorder_gotohome" : "goHome"
                },
                handleAddToCart: function (event) {
                    let _this = this;
                    let recentProducts = _this.model.attributes.recentProducts;
                    let prodSku = $(event.currentTarget).attr('data-sku');
                    var product = _.findWhere(recentProducts, {sku: prodSku});
                    let buyAgainModel = this.model;
                    let price = product.price;
                    let qty = 1;
                    let productData = {
                            "sku": prodSku,
                            "quantity": qty + '',
                            "subTermId": null,
                            "parentSFID": null,
                            "isMain": true,
                            "shipType": 'home',
                            "storeName": 'Home',
                            "address1": '',
                            "city": '',
                            "stateCode": '',
                            "countryCode": '',
                            "postalCode": '',
                            "phone": '',
                            "storeId": '',
                            "price": price + '',
                            "subTotal": (price * qty) + '',
                            "storeHours": '',
                            "storeTimezone": '',
                            "isStoreQuantity": true,
                            "isPickUpLater": false,
                            "isGetPrice": false,
                            "isFromWebStore": true
                        }
                    let reqData = {
                        "cartEncId": CCRZ.pagevars.currentCartID,
                        "products": [productData]
                    }
                    UTIL.showLoader();
                    var remoteCall = _.extend(CCRZ.RemoteInvocation, {className: 'DCMB2B_subscription_controller'});
                    remoteCall.invokeCtx(
                        'addToCartExtension', (JSON.stringify(reqData)),
                        function (res) {
                            if (res && res.success && res.data) {
                                if (res.data.cartEncId) {
                                    try {
                                        CCRZ.pagevars.currentCartID = res.data.cartEncId;
                                        CCRZ.pagevars.queryParams['cartId'] = res.data.cartEncId;
                                        CCRZ.pubSub.trigger('cartChange', res.data.cartEncId);
                                    } catch (err) {
    
                                    }
                                    let toastMsg = CCRZ.pagevars.pageLabels.Toast_Product_Added_Success;
                                    CCRZ.pubSub.trigger("showToastMsg", 'SUCCESS', toastMsg);
                                    UTIL.hideLoader();
                                }
                            } else {
                                // Error handling
                                let errorToastMsg = CCRZ.pagevars.pageLabels.Toast_Product_Added_Fail;
                                CCRZ.pubSub.trigger("showToastMsg", 'ERROR', errorToastMsg);
                                UTIL.hideLoader();
                            }
                        }, {buffer: false, escape: false, nmsp: false}
                    );
                },
                handleBuyAgainSearch: function (event) {
                    var v = this;
                    var searchForm = _.extend($("#searchBuyAgainForm").serializeObject());
                    if(searchForm.searchInput != '' || (searchForm.fromDateStr != '' && searchForm.toDateStr != '')) {
                        buyAgainBackUpSearchFormData = searchForm;
                        v.performBuyAgainSearch(searchForm);
                    }
                },
                performBuyAgainSearch: function(searchForm) {
                    UTIL.showLoader();
                    var remoteCall = _.extend(CCRZ.RemoteInvocation, {className: 'DCMB2B_subscription_controller'});
                    remoteCall.invokeCtx(
                        'fetchRecentOrderItems', null, JSON.stringify(searchForm),
                        function (res) {
                            if (res && res.success && res.data) {
                                buyAgainBackUpModel = res.data.recentProducts
                                CCRZ.myaccountView.subView.render();
                                UTIL.hideLoader();   
                            } else {
                                // Error handling
                                CCRZ.pubSub.trigger("pageMessage", CCRZ.createPageMessage('ERROR', "messagingSection-Error", 'Error Adding Product to the cart!'));
                                UTIL.hideLoader();
                            }
                        }, {buffer: false, escape: false, nmsp: false}
                    );
                },
                resetSearch:function(){
                    var _this = this;
                    let searchFormData={
                        'searchInput': '',
                        'fromDateStr': '',
                        'toDateStr': ''
                    };
                    buyAgainBackUpSearchFormData = searchFormData;
                    _this.performBuyAgainSearch(searchFormData);
                },
                updateDatePicker: function() {
                    var daysArray = CCRZ.pagevars.pageLabels['DaysOfWeek'].split(",");
                    var monthsArray = CCRZ.pagevars.pageLabels['MonthsOfYear'].split(",");
                    var dateFormat = CCRZ.pagevars.pageLabels['Date_Format'];
               
                                   $.fn.datepicker.dates[CCRZ.pagevars.userLocale] = {
                                       days: daysArray,
                                       daysShort: daysArray,
                                       daysMin: daysArray,
                                       months: monthsArray,
                                       monthsShort: monthsArray,
                                       format: dateFormat
                                   };
               
                    $(".requestedDate").datepicker({
                     language: CCRZ.pagevars.userLocale
                    });
                },
                goHome : function(){
                    CCRZ.homePage();
                }
            });

            CCRZ.customBuyAgainView = new CCRZ.views.customBuyAgainView({
                model: new customBuyAgainModel()
            });
            return CCRZ.customBuyAgainView;
        }

    }
});