d("myAccountView", ['ccrz', 'util', 'customSubscriptionView', 'myOrderList', 'customBuyAgainView', 'customPickupPersonView'], function (CCRZ, UTIL, customSubscriptionView, myOrderList, customBuyAgainView, customPickupPersonView) {
    return {
        extendMyAccount: function () {
            let subscView = customSubscriptionView.extendcustomSubscriptionView();
            let buyAgainView = customBuyAgainView.extendcustomBuyAgainView();
            let myPickupPersonView = customPickupPersonView.extendcustomPickupPersonView();
            if (CCRZ.MyAccount) {
                CCRZ.MyAccount = _.extend(CCRZ.MyAccount || {}, {
                    buyAgain: {
                        register: function (registrar) {
                            registrar.registerNewView('buyAgain', 'Buy Again', buyAgainView);
                        }
                    },
                    mySubs: {
                        register: function (registrar) {
                            registrar.registerNewView('mySubs', 'My Subscriptions', subscView);
                        }
                    },
                    myPickupPerson: {
                        register: function (registrar) {
                            registrar.registerNewView('myPickupPerson', 'My Pickup Persons', myPickupPersonView);
                        }
                    },
                    myOrders: {
                        register: function(registrar) {
                            //My Orders stuff
                            var orderList = new myOrderList();
                            var useOrdPaginator = CCRZ.getPageConfig('pgbl.ord', false);
                            if(useOrdPaginator) {
                             CCRZ.orderPaginatorView = new CCRZ.views.navigatePaginationView({
                              model : orderList
                             });
                            }
                         
                            var theView = new CCRZ.views.myOrdersView({
                             model : orderList
                            });
                            
                            registrar.registerNewView('myOrders', CCRZ.pagevars.pageLabels['MyAccount_MyOrders'], theView );
                            if(useOrdPaginator) {
                             CCRZ.orderPaginatorView.listenTo(theView, "pagination:host:rendered", CCRZ.orderPaginatorView.hostRendered);
                            }
                           }
                    }
                });
            }

            CCRZ.pubSub.once("view:contactInfoView:refresh", function (contactView) {
                console.log('contact info view');
                contactView.events["click .clearStore"] = 'removeStore';
                contactView.events["click .changeStore"] = 'handleChangeStore';

                contactView.handleChangeStore = function (event) {
                    CCRZ.storeView.model.set('isSave', true);
                    CCRZ.pubSub.trigger('fetchStoreByZip', {
                        'zipCode': CCRZ.storeView.model.get('selectedStoreZip'),
                        'type': 'header',
                        'isSave': true
                    });
                    window.scroll(0, 0);
                };
                contactView.removeStore = function (event) {
                    let contactIdval = CCRZ.currentUser.ContactId;
                    var remoteCall = _.extend(CCRZ.RemoteInvocation, {className: 'LPM_BB_HeaderController'});
                    remoteCall.invokeCtx(
                        'RemoveStoreInfo', (contactIdval),
                        function (response, event) {
                            if (event.status) {
                                let responseData = response;
                                if (responseData != null) {
                                    $('.geoLocationTurnOn_msz').show();
                                    setTimeout(function () {
                                        window.location.reload();
                                    }, 6000);


                                } else {


                                }

                            }
                        }, {buffer: false, escape: false, nmsp: false}
                    );
                };
                contactView.delegateEvents();
                contactView.render();

                if(CCRZ.myaccountModel.attributes.contactBean.storeContact == true) {
                    let reqData = {};
                    reqData.accountid = CCRZ.myaccountModel.attributes.accountBean.accountNumber;
                    console.log('AR remote call reqData ' + JSON.stringify(reqData));
                    setTimeout(function () {
                        var controller = _.extend(CCRZ.RemoteInvocation, {className: 'LPM_BB_HeaderController'});
                        controller.invokeCtx(
                            'retrieveCheckoutConfigInfo', (JSON.stringify(reqData)),
                            function (res, event) {
                                console.log('AR remote call res ' + JSON.stringify(res));
                                console.log('AR remote call event ' + JSON.stringify(event));
                                if (res.success) {
                                    creditInfo = res.data;
                                    var theCurrency = CCRZ.userIsoCode;
                                    $('.cc_profile_credLimit_value').text(CCRZ.util.format(CCRZ.pagevars.pageLabels['price_' + theCurrency] || CCRZ.pagevars.pageLabels['price_Undefined'] || '$#,###.00', creditInfo.creditLimit));
                                    $('.cc_profile_availBal_value').text(CCRZ.util.format(CCRZ.pagevars.pageLabels['price_' + theCurrency] || CCRZ.pagevars.pageLabels['price_Undefined'] || '$#,###.00', creditInfo.accountBalance))
                                    UTIL.hideLoader();
                                } else {
                                    $('.cc_profile_credLimit_value').text('No AR Account Found');
                                    $('.cc_profile_availBal_value').text('No AR Account Found');
                                    UTIL.hideLoader();
                                }
                            }, {buffer: false,
                                escape: false,
                                nmsp: false}
                        );
                    }, 2000);
                }
            })
            CCRZ.pubSub.once('view:myaccountView:awaitingSubViewInit', function (theView) {
                if (CCRZ.MyAccount.buyAgain) {
                    CCRZ.MyAccount.buyAgain.register(theView);
                }
                if (CCRZ.MyAccount.contactInfo) {
                    CCRZ.MyAccount.contactInfo.register(theView);
                }
                if (CCRZ.MyAccount.addressBooks) {
                    CCRZ.MyAccount.addressBooks.register(theView);
                }

                if (CCRZ.MyAccount.myCarts) {
                    CCRZ.MyAccount.myCarts.register(theView);
                }

                if (CCRZ.MyAccount.myOrders) {
                    CCRZ.MyAccount.myOrders.register(theView);
                }

                if (CCRZ.MyAccount.myWishlists) {
                    CCRZ.MyAccount.myWishlists.register(theView);
                }

                if (CCRZ.MyAccount.mySubs) {
                    CCRZ.MyAccount.mySubs.register(theView);
                }

                if (CCRZ.MyAccount.myInvoices) {
                    CCRZ.MyAccount.myInvoices.register(theView);
                }

                if (CCRZ.MyAccount.myWallet) {
                    CCRZ.MyAccount.myWallet.register(theView);
                }

                if (CCRZ.MyAccount.myPickupPerson) {
                    CCRZ.MyAccount.myPickupPerson.register(theView);
                }

                let viewState = (CCRZ.pagevars.queryParams.viewState ? CCRZ.pagevars.queryParams.viewState : 'viewAccount');
                theView.currIndex = theView.sectionMap[viewState] || 0;
                theView.subView = theView.subViewArray[theView.currIndex].view;
                theView.render();
            });

            CCRZ.pubSub.on("view:myAccountNavView:refresh", function (view) {
                let menus = CCRZ.data.menus;
                if (!_.isUndefined(menus) && menus.length > 0) {
                    for (var i = 0; i < menus.length; i++) {
                        if (menus[i].displayName.toLowerCase() == 'add/manage contacts') {
                            $('.contactManagementLink').removeClass('hidden');
                        }
                    }
                }
            });

        },


    }
});