d("myOrdersView", ['util'], function (UTIL, myOrdersView) {

    return {
        extendMyOrdersView: function () {

            CCRZ.pubSub.once('view:myOrdersView:refresh', function (myOrdersView) {
                console.log('override view myOrdersView');

                myOrdersView.events["click .goToInstoreOrder"] = 'goToInstoreOrder';
                myOrdersView.events["click .inStoreReorder"] = 'handleInstoreReorder';
                myOrdersView.reorder = function (event) {
                    try {
                        UTIL.showLoader();
                        var objLink = $(event.target);
                        var id = objLink.data("id");
                        this.orderList.reorder(id, function (newCartId) {
                            cartDetails(newCartId);
                        });
                    } catch (e) {
                        UTIL.hideLoader();
                    }
                }

                myOrdersView.handleInstoreReorder = function (event) {
                    try {
                        UTIL.showLoader();
                        var objLink = $(event.target);
                        var id = objLink.data("id");
                        var orderList = this.orderList.models;
                        var orderSelected = _.find(orderList,function(x){
                            return x.attributes.name == id;
                        });
                        var orderData = orderSelected.attributes.extrinsic.onlineOrders;
                        var remoteCall = _.extend(CCRZ.RemoteInvocation, {className: 'DCMB2B_subscription_controller'});
                        remoteCall.invokeCtx(
                            'inStoreReorder', (orderData),
                            function (response, event) {
                                if (response.success) {
                                    cartDetails();
                                } else {
                                    UTIL.hideLoader();
                                }
                            }, {buffer: false, escape: false, nmsp: false}
                        );
                    } catch (e) {
                        UTIL.hideLoader();
                    }
                }
                myOrdersView.goToInstoreOrder = function (event) {
                    var transId = $(event.currentTarget).text().trim();
                    var orderList = this.orderList.models;
                    var orderSelected = _.find(orderList,function(x){
                        return x.attributes.name == transId;
                    });

                    var selectedJSON = orderSelected.attributes.extrinsic.onlineOrders;
                    var remoteCall = _.extend(CCRZ.RemoteInvocation, {className: 'DCMB2B_subscription_controller'});
                    remoteCall.invokeCtx(
                        'updateInStoreOrder', (selectedJSON),
                        function (response, event) {
                            if (response.success) {
                                document.location = CCRZ.pagevars.currSiteURL + "ccrz__CCPage?pageKey=InStoreOrder" + getCSRQueryString();            
                            }
                        }, {buffer: false, escape: false, nmsp: false}
                    );
                }

                myOrdersView.delegateEvents();
                myOrdersView.render();
            });

            CCRZ.pubSub.on('pageMessage', function (response) {
                if (response.messages[0].severity == 'ERROR') {
                    UTIL.hideLoader();
                }
            }, this);
        },
    }
});