d("wishlistDetailsView",['util', 'headerModel'], function(UTIL,headerModel) {

    return {
        extendWishlistDetailsView: function(){
            let customHeaderModel = new headerModel();
            CCRZ.pubSub.once('view:wishlistDetailsView:refresh', function(wishlistView){
                wishlistView.events['click .addItem'] = 'handleAddItem';

                wishlistView.handleAddItem = function(event){
                    var objLink = $(event.target);
                    var id = objLink.data("id");
                    var itemModel = this.wishlistItemData.get(id);

                    var sku = itemModel.attributes.prodBean.sku;
                    let qty = 1;
                    let _this = this, subTermId = null, price = null;

                    UTIL.showLoader();
                    let productData = {
                        "sku": sku,
                        "quantity": qty + '',
                        "subTermId": subTermId,
                        "parentSFID": null,
                        "isMain": true,
                        "shipType": 'home',
                        "storeName": 'Home',
                        "address1": '',
                        "city": '',
                        "stateCode": '',
                        "countryCode": '',
                        "postalCode": '',
                        "phone": '',
                        "storeId": '',
                        "price": null,
                        "subTotal": null,
                        "storeHours": '',
                        "storeTimezone": '',
                        "isStoreQuantity": true,
                        "isPickUpLater": false,
                        "isGetPrice": true,
                        "isFromWebStore":true
                    }, reqData = {
                        'cartEncId': CCRZ.pagevars.currentCartID,
                        'products': [productData],
                        "lookupMPN": false
                    }
                    customHeaderModel.addToCart(JSON.stringify(reqData), function (res, evt) {
                        if (res && res.success && res.data) {
                            if (res.data.cartEncId) {
                                try {
                                    CCRZ.pagevars.currentCartID = res.data.cartEncId;
                                    CCRZ.pagevars.queryParams['cartId'] = res.data.cartEncId;
                                    CCRZ.pubSub.trigger('cartChange', res.data.cartEncId);
                                } catch (err) {
                                }
                                //CCRZ.pubSub.trigger("pageMessage", CCRZ.createPageMessage('INFO', "messagingSection-wishlist-Info", 'Product Added Sucessfully!'));
                                let toastMsg = CCRZ.pagevars.pageLabels.Toast_Product_Added_Success;
                                CCRZ.pubSub.trigger("showToastMsg", 'SUCCESS', toastMsg);
                            }
                        } else {
                            // Error handling
                            //CCRZ.pubSub.trigger("pageMessage", CCRZ.createPageMessage('ERROR', "messagingSection-wishlist-Error", 'Item can not be added from Quick Order, visit Product details for more options!'));
                            let errorToastMsg = 'Item can not be added from Quick Order, visit Product details for more options!';
                            CCRZ.pubSub.trigger("showToastMsg", 'ERROR', errorToastMsg);
                        }
                        UTIL.hideLoader();
                    });
                };
                wishlistView.delegateEvents();
                wishlistView.render();
            });

        }
    }
});